<?php
/* Das Script ermöglicht es mit einem Klick die Alben einer Kategorie alphanbetisch (aufwärts oder abwärts) zu sortieren
Anleitung:
1. Ein Backup der Copperminedatenbank durchführen
2. Script in das Coppermine-Verzeichniss kopieren
3. Die Sortierart in der entsprechenden Kategorie auswählen
4. Script nach Benutzung aus dem Hauptverzeichniss entfernen

Bei Fragen oder Anregungen einfach eine Email an stephan@steb-studio.de

/* Use the script for a oneclick sort all albums in a category alphabetical
Manual:
1. Backup your Copperminedatabase
2. Copy script in the directory of your copperminegalery
3. Use the link for sort  - "sortieren aufsteigend" = abc...xyz" or "sortieren absteigend" = zyx...cba"
4. Remove the script after use

Questions oder comments? Send a mail to stephan@steb-studio.de */ 
?>

<? function formular_sortierung($_tabprefix) { 
//-----------------------------------------
//--- Einlesen der Alben und Kategorien ---
//--> Einlesen der Kategorien
 $_sql = mysql_query("SELECT * FROM ".$_tabprefix."categories");
 unset($_kat_tabelle);
 while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
	$_cid = $_row["cid"];
	$_kat_tabelle[$_cid]["name"] = $_row["name"];
	$_kat_tabelle[$_cid]["pid"] = $_row["parent"];
	$_kat_tabelle[$_cid]["description"] = $_row["description"]; }
 foreach ($_kat_tabelle as $_cid => $_werte) {
	$_pid = $_werte["pid"];
	if ($_werte["pid"] != 0) $_kat_tabelle[$_cid]["parent"] = $_kat_tabelle[$_pid]["name"]; }
//--> Einlesen der Alben
 $_sql = mysql_query("SELECT * FROM ".$_tabprefix."albums");
 $_alben = array();
 $_kat_alben_temp = array();
 while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
 array_push($_alben, $_row);
 array_push($_kat_alben_temp, $_row["category"]); }
 $_kat_alben_temp = array_unique($_kat_alben_temp); //-> Kategorien mit Alben
 $_kat_alben = array();
 foreach ($_kat_alben_temp as $_key => $_cid) {
	$_details = $_kat_tabelle[$_cid];
	$_details["cid"] = $_cid;
	array_push($_kat_alben, $_details); }
//-->Sortieren der Albenkategorien nach Name und Parentname
 foreach ($_kat_alben as $_key => $_row) {
	$_kat_name[$_key] = $_row["name"];
	$_parent[$_key] = $_row["parent"]; }
 array_multisort($_kat_name, SORT_ASC, $_parent, SORT_ASC, $_kat_alben);

//--->Formular fuer Sortierung
 echo "\n<form action='sortierung.php' method='post'><table style='border: thin solid black; width: 800px;'>";
 echo "\n <tr><td>Gehe zu Kategorie:<br>";
 echo "\n<div style='color: red; font-size:0.9em'>Es werden nur Kategorien mit Alben angezeigt</div>";
 foreach ($_kat_alben as $_key => $_value) {
	$_cid = $_value["cid"];
	echo "-> <a href='#".$_cid."'>".$_value["name"]."</a> <-"; }
 echo "\n </td></tr>";
 foreach ($_kat_alben as $_key => $_value) {
	$_cid = $_value["cid"];
	echo "\n <tr><td id='kat_name'>";
	echo "\n<h2><a name='".$_cid."'></a>Kategorie: ";
	echo "<a href='./index.php?cat=".$_cid."' target='_blank'>".$_value["name"]."</a>";
	echo " <-- ".$_value["parent"]."</h2>";
	echo "\n<p id='beschreibung'><b style='font-style: normal;'>Beschreibung:</b> ".$_value["description"]."</p></td>";
	echo "\n </tr><tr>";
	echo "\n<td id='kat_alben'><p>enthaltene Alben:<br>";
	$_sql = mysql_query("SELECT * FROM ".$_tabprefix."albums WHERE category LIKE '".$_cid."' ORDER BY pos ASC");
	$_x=0;
	while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
	 $_x=$_x+1;
	 echo "<div style='float: left; width: 49%'>--> ".$_row["title"];
	 echo "</div>";
	 if ($_x==2) { echo "<br>"; $_x=0; }
	}
 	echo "</p></td></tr>";
 	echo "\n <tr><td id='sortlink' style='text-align: right;'>";
 	echo "\n<a href='sortierung.php?sortkat=".$_value["cid"]."&sorttyp=abc' target='_self'>aufsteigend (abc...xyz)</a>";
 	echo " - <a href='sortierung.php?sortkat=".$_value["cid"]."&sorttyp=zyx' target='_self'>absteigend (zyx...cba)</a>";
	echo "\n </td></tr>"; }
 echo "</table></form>";

return; } ?>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de" dir="ltr">
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
 <meta http-equiv="Pragma" content="no-cache" />
 <title>Albensortierer von SteB-Studio</title>
 <style type='text/css'>
table {
	font-size: 14px; }
td#kat_name {
	border-top: medium solid black;
	border-bottom: thin dotted black;
	width: 33%; }
td#kat_name h2 {
	font-size: 1.1em;
	font-weight:bold;
	margin: 1px;
	padding: 1px; }
td#kat_name p {
	font-size: 0.9em;
	font-style: italic;
	margin: 1px;
	padding: 1px; }

td#kat_details {
	border-top: thin solid black;
	border-bottom: thin solid black; }


td#kat_alben {
	font-size:0.9em; }

td#sortlink a {
	font-size: 0.9em;
	font-weight: bold; }
td#kategoriename {
	border-top: thin solid black;
	width: 33%; }
 </style>
</head>
<body>
<? 
//--- Einbinden der Coppermine-Configdatei
 include ("./include/config.inc.php");
 mysql_connect($CONFIG['dbserver'], $CONFIG['dbuser'], $CONFIG['dbpass'])
    or die("Keine Verbindung möglich: " . mysql_error());
 mysql_select_db($CONFIG['dbname']);

//--- Aufruf Sortieralgorythmus ---
 if(isset($_GET["sorttyp"])) {
	$_sql = mysql_query("SELECT * FROM ".$CONFIG['TABLE_PREFIX']."albums WHERE category = ".$_GET["sortkat"]);
	$_alben = array();
	while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
	 array_push($_alben, $_row); }
	 // --- sortieren der Wert ---
	 foreach ($_alben as $_key => $_row) {
		$_albumtitel[$_key] = $_row["title"]; }
	 switch ($_GET["sorttyp"]) {
		case "abc":
		 array_multisort($_albumtitel, SORT_ASC, $_alben);
		 break;
		case "zyx":
		 array_multisort($_albumtitel, SORT_DESC, $_alben);
		 break; }
	 $_pos = 100;
	 foreach ($_alben as $_key => $_value) {
		$_sql = "UPDATE ".$CONFIG['TABLE_PREFIX']."albums SET `pos` = '$_pos' WHERE `".$CONFIG['TABLE_PREFIX']."albums`.`aid` =".$_value["aid"].";";
		mysql_query($_sql);
		$_pos++; }
	echo "\n<form action='sortierung.php' method='post'><table style='border: thin solid black; width: 800px;'>";
	$_sql = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."categories WHERE cid = ".$_GET["sortkat"].";";
	$_sql = mysql_query($_sql);
	$_kat = array();
	while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
	 $_kat = $_row["name"]; }
	echo "\n <tr><td colspan='2'><h2>Ergebniss für ".$_kat."</h2></td></tr>"; }
	$_sql = mysql_query("SELECT * FROM ".$CONFIG['TABLE_PREFIX']."albums WHERE category LIKE '".$_GET["sortkat"]."' ORDER BY pos ASC");
	$_x = 0;
	while ($_row = mysql_fetch_array($_sql, MYSQL_ASSOC)) {
	 $_x=$_x+1;
	 if ($_x == 1) echo "<tr>";
	 echo "<td style='width: 50%'>".$_row["title"]."</td>";
	 if ($_x==2) { echo "</tr>"; $_x=0; }
	} echo "<tr><td colspan=2 style='text-align: right'><a href='#".$_GET["sortkat"]."'>zur Kategorie</a></td></tr></table></form>";
 formular_sortierung($CONFIG['TABLE_PREFIX']);
 mysql_close(); ?>
 <p style='font-size:0.8em; text-align:right'>Entwickelt f&uumlr Coppermine-Galery von <b>Stephan B&oumlhlke - <a href='steb-studio.de' target='_self'>www.steb-studio.de</a></b></p>
</body></head>
